#include <AppKit/AppKit.h>
#include "AppDelegate.h"
#include "WinController.h"

static AppDelegate *sharedInstance;
static WinController *winCont;

@implementation AppDelegate

/*
 * The following a delegated notifications
 */
- (void)applicationWillFinishLaunching:(NSNotification *)notif
{
	NSLog(@"appWillFL");
	// Create menus in here,  could also create windows,  but not orderFront
}

- (void)applicationDidFinishLaunching:(NSNotification *)notif
{
	NSLog(@"appDidFL");
	winCont = [[WinController alloc] init];
}

- (void)applicationWillBecomeActive:(NSNotification *)notif
{
	NSLog(@"appWillBA");
}

- (void)applicationDidBecomeActive:(NSNotification *)notif
{
	NSLog(@"appDidBA");
}

- (void)applicationWillResignActive:(NSNotification *)notif
{
	NSLog(@"appWillRA");
}

- (void)applicationDidResignActive:(NSNotification *)notif
{
	NSLog(@"appDidRA");
}

- (void)applicationWillHide:(NSNotification *)notif
{
	NSLog(@"appWillH");
}

- (void)applicationDidHide:(NSNotification *)notif
{
	NSLog(@"appDidH");
}

- (void)applicationWillUnhide:(NSNotification *)notif
{
	NSLog(@"appWillUnh");
}

- (void)applicationDidUnhide:(NSNotification *)notif
{
	NSLog(@"appDidUnh");
}

#if 0 /* now noisy on gnustep */
- (void)applicationWillUpdate:(NSNotification *)notif
{
	NSLog(@"appWillUpd");
}

- (void)applicationDidUpdate:(NSNotification *)notif
{
	NSLog(@"appDidUpd");
}
#endif

- (void)applicationWillTerminate:(NSNotification *)notif
{
	NSLog(@"appWillTerm");
}

/*
 * The following are direct delegations.
 */
- (BOOL)applicationShouldTerminate:(id)sender
{
	NSLog(@"appShouldTerm?");
	return YES;
}

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(id)sender
{
	NSLog(@"appShouldTermALWC?");
	return YES;
}

/* ======== End of Delegated methods ======== */

- (void)windowOnControllerWillClose
{
	NSLog(@"wc winWillClose");
	[winCont release];
	winCont = nil;
}

+ (AppDelegate *)sharedInstance
{
	if (!sharedInstance)
		sharedInstance = [[AppDelegate alloc] init];
	return sharedInstance;
}
@end
