#include <AppKit/AppKit.h>
#include "WinController.h"
#include "TextView.h"
#include "text.h"

@implementation WinController

- (void)windowWillClose:(NSNotification *)notif
{
	_window = nil;	// So release in dealloc is safe/no-op.
	[[NSApp delegate] windowOnControllerWillClose];
}

/*
 * The following are direct delegations from NSWindow.
 */
- (BOOL)windowShouldClose:(id)sender
{
	return YES;
}

/* ======== End of Delegated methods ======== */

#define WW_MASK	((unsigned)(\
		 NSTitledWindowMask|\
		 NSClosableWindowMask|\
		 NSMiniaturizableWindowMask|\
		 NSResizableWindowMask|\
		 0)\
		)
-(id)init
{
	NSRect rect;

	rect = NSMakeRect(100,100, 500,500);

	_window = [[NSWindow alloc]
		initWithContentRect:	rect
			  styleMask:	WW_MASK
			    backing:	NSBackingStoreBuffered
			      defer:	NO];
	if (!_window) return nil;
	[_window setDelegate: self];
	[_window setTitle: @"Some title Text"];

	_textStorage = [[NSTextStorage alloc] init];
	load_text_storage(_textStorage);

	rect = NSMakeRect(0,0, 500,250);
	_normView = [[TextView alloc] initWithFrame:rect andStorage:_textStorage isFlipped:NO];
	if (!_normView)
		return nil;
	[[_window contentView] addSubview:_normView];
	[_normView release];

	rect = NSMakeRect(0,250, 500,250);
	_flipView = [[TextView alloc] initWithFrame:rect andStorage:_textStorage isFlipped:YES];
	if (!_flipView)
		return nil;
	[[_window contentView] addSubview:_flipView];
	[_flipView release];

	[_window orderFront: nil];

	return self;
}

- (void)dealloc
{
	[_textStorage release];
	[_window release];
	[super dealloc];
}
@end
